#!/usr/bin/perl5
#
# Superguest.cgi version 1
# copyright 2000 Leif M. Wright
# leif@conservatives.net
# http://www.conservatives.net/atheist/scripts/
# You may copy this script and give it away, but you may not sell it.
# This header must accompany any part of this script that is copied.
# Instructions are in the readme.txt file. If you got this by viewing
# source online, you may get the instructions at
# http://www.conservatives.net/atheist/scripts/superguestreadme.txt
# 
# Superguest is an extremely flexible guestbook that offers all of today's 
# most popular features, while also requiring NO knowledge of Perl to get
# up and running. This guestbook incorporates all of the most popular features
# of my other guestbooks, and the ease-of-use of my simplest guestbook.
# Simply put, this is the best guestbook I have.
#
# Before using this script, read the readme.txt file. It contains IMPORTANT
# instructions without which you will have trouble running this script
#
# STANDARD DISCLAIMER: I provide this and all my scripts for educational
# purposes only - which is why I comment them thoroughly. I cannot be responsible
# for anything this software does. Please eat your vitamins and use this script
# at your own risk. -- And call your mother!
#
# In the comments below, you'll often see me referring to the 0th item. Perl does
# not count from 1; it begins counting at 0. Therefore, when I refer to the 0th
# item, I'm really referring to the 1st item. When I refer to the 1st item, I'm really
# referring to the 2nd item and so on. This helps keep me thinking like Perl thinks.

require 'web-lib.pl';

###########
# This must point to your configuration file
# MUST be unix directory, not a url
$config = "/usr/home/leif/public_html/conservatives/atheist/scripts/superguestconfig";
###########

#sends script into the Parse sub in the web-lib.pl library to read the 
#input string and parse it into legible characters
&Parse;

#opens the configuration file, dumps it into an array
open (CONFIG,"$config") || &Error("Can\'t open $config. Reason: $! . This script will not run without a configuration file. Please read the readme file and reconfigure accordingly.");
@Config=<CONFIG>;
close(CONFIG);

#for each item in the array, do the following
foreach $figgy (@Config)
{
    #cut off newline characters so that all we have is actual data
    #from the config file. Believe it or not, this can be a very
    #annoying problem if you don't know it's there...
    chomp($figgy);
    
    #split item into key/value pairs for config hash
    ($Ckey,$Cvalue) = split(/=/,$figgy,2);
    
    #create config hash, using values above
    $config{$Ckey} = $Cvalue;
}

#assign scalar values to hash items to keep me from having
#to type curly braces over and over. Technically what I'm doing
#is dumping the hash values into new scalars. The two are no longer
#related after that. If I change the hash, the new scalars don't change.
$GuestBook = $config{GuestBook};
$newform = $config{newform};
$mailprog = $config{mailprog};

#read "fields" field from config file, dump it into an array by splitting at pipe character.
#The fields field is the guts of the flexibility here. Therefore, this nondescript looking
#line is one of the most important in the script.
@fields = split(/\|/,$config{fields});

#set count to 0
$FieldsCount=0;

#count each item in the fields array - this count will be used 
#often through the rest of the script to assign numerical limits
#as we iterate through the fields array processing each item.
foreach (@fields)
{
    $FieldsCount++;
}

#if the %in hash exists, that means there was some input from
#the input string, meaning the script will need to do something
#with the input. If the %in hash doesn't exist, there wasn't any
#input, and the script should default to the View subroutine, which
#will take the user to page one of the guestbook.
unless (%in)
{
    $ViewPage = 1;
    &View;
}


#if there's an input value for the 0th item equaling "View,"
#the 1st item will be which page to view, unless there is no
#1st item, which means view the first page.
if ($in{0} =~ /View/i)
{
    if ($in{1})
    {
	$ViewPage = $in{1};
	&View;
    }
    else
    {
	$ViewPage = 1;
	&View;
    }
}

#I'm not sure I still need this, but I'm too lazy to find out.
#html form input keys come with spaces changed to pluses by the
#parse routine in web-lib.pl. Here, I change them back to
#spaces so my later subroutines will recognize them and be
#able to match them to their correspondents in the @fields array
foreach $key (keys %in)
{
    $value = $in{$key};
    $key =~ s/\+/ /g;
    $in{$key} = $value;
}


#if the 0th input value is "Edit," we know the user wants to edit
# an entry. Set $EditEntry to the value of the 1st input item
if ($in{0} =~ /Edit/i)
{
    $EditEntry = $in{1};
    &Edit;
}

#if the 0th input item is "Sign," the user wants to sign the guestbook
if ($in{0} =~ /Sign/i){&Sign;}

#the previous tests looked for input values that were not
#associated with name/value pairs. Since POST operations ONLY 
#give name/value pairs, this tests to see if the in hash contains
#a key called "action" and if the value for that key matches the
#following strings. If it does, the script goes to the appropriate
#subroutine.
if ($in{action} eq "AddMe"){&AddMe;}
if ($in{action} eq "Change"){&Change;}
if ($in{action} eq "Add"){&Add;}


##### BELOW ARE SUBROUTINES
sub Change
{
    # This is the subroutine that actually changes the guestbook
    # entry after you have told it to in the edit subroutine below. 
    # Don't let user go any farther unless their password is right
    &Error("Password incorrect") unless ($in{Password} eq $config{Password});

    #Read the guestbook, dump its contents into an array
    open(TOREAD,"$GuestBook") || &Error("Can't open $GuestBook for reading in Change sub. Reason: $!");
    @ToRead=<TOREAD>;
    close(TOREAD);
    
    #open guestbook for overwriting, lock it using UNIX's flock command.
    #some systems don't support the flock command (Apple comes to mind).
    #if you're running a non-unix system, the flock command could choke the script
    #for you. The solution, however, is easy. Just put a pound sign (#) before the
    #word "flock" below, and viola, problem solved. There are two flock commands
    #in this script. The other one is farther down.
    open(TOWRITE,">$GuestBook") || &Error("Can't open $GuestBook for writing in Change sub. Reason: $!");
    flock(TOWRITE,2) || &Error("Can\'t lock $GuestBook in Change sub. Reason: $!. If you continue to get this error, it may mean your server does not support the flock protocol. Comment out the flock line in the AddMe subroutine to avoid this error in the future.");
    
    #since we allow the user to either edit or delete entries, check to
    #ensure we're supposed to edit and not delete
    if ($in{ToDo} eq "Edit")
    {
	foreach $ToWrite (@ToRead)
	{
	    ($TheRank,$EvthngElse) = split(/\|/,$ToWrite,2);
	    if ($TheRank eq $in{Rank})
	    {
		print TOWRITE "$TheRank\|";
		
		for ($i = 1; $i < $FieldsCount; $i++)
		{
		    #Calls the value from the "in" hash that matches
		    #the nth item on the "fields" array (where "n" is represented by $i)
		    #For instance, if the values at $fields[1] is "name", then this prints
		    #$in{name}, whose value hopefully is the user's name
		    print TOWRITE "$in{$fields[$i]}";
		    
		    #if the item is the comments field, it's the last field, and 
		    #we don't want a pipe after it. Otherwise, we do want a pipe
		    #to delimit the guestbook file item.
		    if ($fields[$i] !~ /comments/gi)
		    {
			print TOWRITE "\|";
		    }
		    
		}
		next;
	    }
	    
	    #if the rank of the guestbook item does not match the 
	    #rank passed to the script through the http header, just
	    #print the item; it's not the one we're editing.
	    else
	    {
		print TOWRITE "$ToWrite";
	    }
	}
	close(TOWRITE);
	#Return an html page letting the user know the edits have been done.
	&IDidIt;
	exit;
    }
    
    #if the user wanted to delete the item instead of edit it, go through this loop.
    elsif ($in{ToDo} eq "Delete")
    {
	foreach $ToWrite (@ToRead)
	{
	    ($TheRank,$EvthngElse) = split(/\|/,$ToWrite,2);
	    if ($TheRank eq $in{Rank})
	    {
		#the "next" command tells the program to simply skip this
		#item. This messes up the rank numbers (it leaves one out),
		#but those will be fixed the next time someone signs the guestbook.
		#This is sort of the poor man's way of deleting an item, but the only
		#more efficient way was to treat the items as a hash tied to a dbm
		#file, but I figured that was too complicated for a novice user to 
		#keep up with. This, I believe, is much easier on the webmaster.
		next;
	    }
	    else
	    {
		print TOWRITE "$ToWrite";
	    }
	}
	close(TOWRITE);
	&IDidIt;
	exit;
    }
}		
	
sub IDidIt
{
    #prints the html/text header. Script will give an error without this call.
    &Header;
    
    #Gets user-defined header file. Passes this subroutine name onto the GetSiteHeader
    #sub so that if there's an error, you can know exactly where in the program it happened.
    &GetSiteHeader("IDidIt");
    print "<h1>Action was successful</h1>\n";
    if ($in{ToDo} eq "Edit")
    {
	print "I have made the changes you requested.<br>";
	print "<a href=$newform?view>Click here to return to guestbook</a>\n";
	&GetSiteFooter("IDidIt");
	exit;
    }
    else
    {
	print "I have deleted the requested entry.";
	print "<a href=$newform?view>Click here to return to guestbook</a>\n";
	&GetSiteFooter("IDidIt");
	exit;
    }
}
	
	
sub Edit
{
    &Header;
    &GetSiteHeader("Edit");
    
    #Open the guestbook and dump the information into an array
    open (GETEDIT,"$GuestBook") || &Error("Can't open $GuestBook for read in Edit sub. Reason: $!");
    @EditArray=<GETEDIT>;
    close(GETEDIT);
    
    #process each item in the array with the following loop
    foreach $EditArray (@EditArray)
    {
	#create an array from the item by splitting it at the pipe character
	@NewArray = split(/\|/,$EditArray);
	
	#if the first item in the new array equals the item passed to the script
	#from the link, we've arrived at the item we want to edit.
	if ($NewArray[0] eq $EditEntry)
	{
	    print "<h1>Edit guestbook entry</h1>\n";
	    print "<form action=$newform method=POST>\n";
	    print "<input type=hidden name=action value=Change>\n";
	    
	    #assigns rank's value to match the 0th item on the new array
	    #that's so we don't accidentally edit the wrong item
	    print "<input type=hidden name=Rank value=$NewArray[0]>\n";
	    print "<b>YOUR PASSWORD:</b> <input type=password name=Password><br>\n";
	    print "Take this action: <select name=ToDo><option>Edit<option>Delete</select><br>\n";
	    
	    #keep doing this loop until you've processed as many items as are in
	    #the "fields" variable in the config file.
	    #Since we already know $NewArray[0] = rank, we must begin processing
	    #this item at the 1st array item, not the 0th. Therefore, we set the count
	    # to 1 instead of the customary 0.
	    for ($i = 1; $i < $FieldsCount; $i++)
	    {
		if ($fields[$i] !~ /comments/gi)
		{
		    print "<b>$fields[$i]:</b> <input type=text name=\"$fields[$i]\" value=\"$NewArray[$i]\"><br>\n"; 
		}
		
		#if the item is a comment, process it in a textarea, not a text field.
		else
		{
		    print "<b>$fields[$i]:</b><br><textarea name=\"$fields[$i]\" rows=10 cols=40>$NewArray[$i]</textarea>\n";
		}
	    }
	    print "<br><input type=submit value=\"Make Changes\"></form>\n";
	    &GetSiteFooter("Edit");
	}
    }
    exit;
}

sub View
{
    &Header;
    &GetSiteHeader("View");
    if ($config{Title})
    {
        print "<center><h3>$config{Title} page $ViewPage</h3>\n";
    }
    else
    {
	print "<h3>Guestbook, page $ViewPage</h3>\n";
    }
    
    print "<a href=$newform?Sign>Sign the guestbook</a><hr noshade size=1></center>\n";
    
    #make sure the script starts with a zero value
    #for how many people have signed the guestbook
    $howmanylines = 0;
    
    #read the guestbook, dump it into an array
    open (INFO, "$GuestBook") || &Error("Can\'t open $GuestBook for line count in View sub. Reason: $!");
    @slammie = <INFO>;
    close(INFO);
    
    
    #count each line in the guestbook. This should tell us how many
    #people have signed it.
    foreach $slammie (@slammie)
    {
	$howmanylines++;
    }
    
    #linecount tells us how many lines we have processed below.
    #since, at this point, we haven't processed any, we start with 0
    $linecount = 0;
    
    #open the guestbook again, dump its contents into another array.
    open (THEBOOK, "$GuestBook") || &Error("Can\'t open $GuestBook for reading in View sub. Reason: $!");
    @information = <THEBOOK>;
    close(THEBOOK);
    
    #for each item in the guestbook do the following loop
    $StartLine = ($ViewPage * 10) - 10;
    $EndLine = $StartLine + 10;

    
    if ($ViewPage > 1)
    {
	
	#since this guestbook displays 10 entries per page, we must
	#determine which 10 entries to display. If we are not on the 
	#first page, do the following
	foreach $information (@information)
	{
	    #skip each line until we get to the entry that should
	    #be first on our page.  Then, until we have processed
	    #the 10 correct entries, continue this loop. 

	    if ($linecount < $StartLine)
	    {
	       
		$linecount++;
		 next;
		
	    }
	    elsif ($linecount < $EndLine)
	    {
		&GetEntry;
		$linecount++;
	    }
	}
    }
    	
    #if we're on page one, all we have to do is generate
    #the entries until we reach a count of ten entries.
    else
    {
	foreach $information (@information)
	{
	    if ($linecount < 10)
	    {
		&GetEntry;
		$linecount++;
	    }
	}
    }
    &GenerateRemaining;
    &GetSiteFooter;
    exit;
}
	
sub GetEntry
{
    #turn entry into an array by splitting it at
    #the pipe character.
    @TheEntry = split(/\|/,$information);
    
    #iterate through each item in the entry array
    #and create a hash pair with each item, based
    #upon the values in $config{fields}.
    for ($i = 0; $i < $FieldsCount; $i++)
    {	    
	$entry{$fields[$i]} = $TheEntry[$i];
    }
    
    
    #call the htmlmiddle subroutine, which will then use
    #the current array to replace tags in template with
    #user data. Here's the flow of data:
    # Getentry turns entry into array.
    # HtmlMiddle uses array to get information
    # for template manipulation.
    &HtmlMiddle;
    
}

sub HtmlMiddle
{
    #open the template, dump it into an array
    open (HELPER,"$config{template}") || &Error("Can\'t Open $config{template} in HtmlMiddle sub. Reason: $!");
    @TMPLT=<HELPER>;
    close (HELPER);

    #process each item in the template array
    foreach $templ (@TMPLT) 
    {
	#this iterates through each item in the fields
	#array  and replaces matching items in the template
	#with the correct values from the guestbook
	for ($i = 0; $i < $FieldsCount; $i++)
	{
	    $templ =~ s/\[$fields[$i]\]/$entry{$fields[$i]}/gi;
	}
	print "$templ";
    }
}


sub GenerateRemaining
{
    #the total number of entries minus how many
    #have been processed divided by ten should give a count of how many
    #pages have not yet been viewed.
    $Remaining = ($howmanylines - $linecount) / 10;
    
    #if that integer is 1 or greater
    if ($Remaining >= 1)
    {
	#split real number from decimals
	($PagesRemain,$TheDecimal) = split(/\./,$Remaining);
	#if there's a decimal, there's a short page
	#at the end. Adding one to the Page count
	#rounds up so those entries don't "disappear"
	if ($TheDecimal)
	{
	    $PagesRemain++;
	}
    }
    #if more than 0 but less than one page remains,
    #we are close to the end of the guestbook, with
    #less than 10 entries remaining. That means
    #there is a short page left. Set page value to 1.
    elsif (($Remaining > 0) && ($Remaining < 1))
    {
	$PagesRemain = 1;
    }
    #otherwise, we're on the last page.
    else
    {
	$PagesRemain = 0;
    }
    
    #This gives the user a heads up on where they are in the guestbook.
    #Laziness is usually a programmer virtue, but there's too much
    #grammarian in me to appreciate things such as: "There are 1 pages remaining."
    #That is just laziness on the programmer's part. If there is one page left,
    #the program should use proper English to say so. That's what the stuff
    #below does.
    $TotalPages = ($PagesRemain + $ViewPage);
    print "<p><center><font size=-2>There are $TotalPages pages in the guestbook ($howmanylines entries).<br>\n";
    print "You are on page <b>$ViewPage</b>.\n";
    if ($PagesRemain > 1)
    {
        print "There are <b>$PagesRemain</b> pages remaining.<br>\n";
    }
    elsif ($PagesRemain == 1)
    {
        print "There is one page remaining.<br>\n";
    }
    else
    {
        print "You are on the last page.<br>\n";
    }
    
    if ($ViewPage > 1)
    {
        $BackPage = $ViewPage - 1;
        print "<a href=$newform?View&$BackPage>Go back to page $BackPage</a>\n";
    }
    if (($ViewPage > 1) && ($PagesRemain > 0))
    {
        print "  \| \n";
    }
    
    if ($PagesRemain > 0)
    {
	$NextPage = $ViewPage + 1;
	print "<a href=$newform?View&$NextPage>Go to page $NextPage</a>.\n";
    }
    print "</center></font>\n";
}

sub CheckBanned
{
    #the subroutine name is a bit of a misnomer. This doesn't just
    #check to see if they're banned. It also checks to see if they've
    #signed the guestbook during this browser session. If they have,
    #it tells them they can't sign again.
    if ($config{MultipleSign} eq "no")
    {
	foreach (split(/; /,$ENV{'HTTP_COOKIE'})) 
	{
	    ($cookie,$value) = split(/=/);
	    $Cookies{$cookie} = $value;
	    if ($Cookies{SuperGuest})
	    {
		&Error("I'm sorry. You cannot sign my guestbook more than one time a day. Please come back tomorrow. Thank you.");
	    }
	}
    }
    
    #THIS is the part that actually tests to see if you've banned them. It's not foolproof,
    #because many ISPs don't assign static IP addresses, which means some people's IP address
    #will change every time they log on. Each ISP only has a limited number of IP addresses available,
    #though, so if you're diligent, you'll eventually get them.
    @bannedlist = split(/\|/,$config{Banned});
    foreach $bannedlist (@bannedlist) 
    {  
	if ($ENV{REMOTE_HOST} eq $bannedlist)
	{ 
	    &Error("You have been banned from the guestbook. Sorry, you cannot sign.");
	}
    }
}

sub CheckRequired
{
    #at first blush, this might seem a bit more
    #complicated than it needs to be. However, there's
    #a method to my madness. Since I have no idea
    #what fields you'll be processing and what fields
    #you'll want to require, I have to deal with things
    #I can't define. Therefore, the most efficient way
    #for me to do it is to populate a hash with your
    #data. You'll see below.
    #First, I make an array out of the items you
    #define as required in your config file.
    @required = split(/\|/, $config{Required});
    
    #then, for each item in my new array,
    #I create a hash key/value pair after
    #I use perl's chomp command, which removes
    #any newline characters that might be lurking
    #around in my array item. The new hash I create
    #here will then serve as my "control" to which 
    #I will compare the input hash.
    foreach $required (@required) 
    {
	chomp($required);
	$Needed{$required} = "yes";
    }
    #Here I iterate the %in hash (which contains
    #the httpd input) by its keys. For each key
    #in the hash, I create a new hash if the key's
    #value contains data (otherwise, I don't want 
    #the key in my new hash, because it's empty.)
    foreach $box (keys %in)
    {
	$contents = $in{$box};
	if ($contents ne '')
	{
	    $Found{$box} = $contents;
	}
    }
    
    #Now I iterate my %Needed hash, checking each
    #key to see if the %Found hash contains a matching
    #key. If the %Found hash doesn't have a matching key,
    #then I know a required field has been left blank. Since
    #it is possible for more than one field to have been left
    #blank, instead of immediately returning an error, I instead
    #populate a new array with each missing field. I'll later
    #use the array to tell the user what they did wrong.
    foreach (keys %Needed)
    {
	#sends up a flag if a required key does not exist
	unless ($Found{$_})
	{
	    push(@uncommon, $_);
	    next;
	}
    }
    
    #if the @uncommon array exists, it must contain
    #the name of a required field that the user left
    #blank. Knowing that, I send the user to an error
    #page to give them a chance to rectify their error.
    if (@uncommon)
    {
	&Header("Error! Required fields left blank!");
	print "You left one or more required fields blank. They are below:<ul>\n";
	foreach $RequiredBlank (@uncommon)
	{
	    print "<li>$RequiredBlank\n";
	}
	print "</ul>Please go back and fill in all the required fields.\n";
	exit;
    } 
}
    
    

sub AddMe
{
    &CheckBanned;
    &CheckRequired;
    
    #If the user codes html into a field and you tell the 
    #script to ban html, this will chide them for the attempt.
    foreach (keys %in)
    {
	$value = $in{$_};
	if (($config{PermitHtml} eq "no") && ($value =~ /<|>/gi))
	{
	    &Error("You cannot code html into my guestbook. Sorry. Please go back and reformat your entry.");
	}
	
	#This runs each value through the cuss word filter.
	#if the filter catches the user cussing, it will
	#stop them in their tracks and tell them to wash
	#their keyboard out with soap.
	&CheckForCussing($value);
	
	#Few things annoy me more than wiseacres typing tons and tons of characters
	#in a row, making my guestbook continue off the right side of the page. Arrgh!
	#this checks to make sure they haven't done that. If they have, it won't let
	#them get away with it. It works like this: it pumps each entry value
	#into a new array, then below, it checks each item for flame (see foreach (@ContentList) below)
	push (@ContentList,$value);
    }
    if ($BadFound)
    {
	$Hed{Bg} = "red";
	
	&Header;
	print "<font face=Verdana,Arial,Helvetica color=white>\n";
	print "<h1>Offensive language prohibited!</h1>\n";
	print "You can't enter profanity in our guestbook. The following words in your entry were offensive:<br>\n";
	print "<ul>\n";
	foreach $cus (@BadWordFound)
	{
	    print "<li> <b>$cus</b><br>\n";
	}
	print "</ul>\n";
	exit;
    }
    foreach (@ContentList)
    {
	@CommentsTester = split(/ /, $_);
	#For each item in the new array, I test the length. Since I split
	#the values at the space character, if this item is longer than 
	#40 characters, chances are the user is trying to flame me -- or their
	#name is just too stinking long.
	foreach $comm (@CommentsTester)
	{
	    $theLength = length($comm);
	    if ($theLength > 40)
	    {
		#Nobody loves a challenge like a butthead who wants to flame your guestbook.
		#Since I don't want that, as soon as I test for the flame, I send the user
		#a cookie that effectively locks them out from trying to sign the guestbook
		#again. Smart users can get around it by deleting the cookie this
		#script sends them, but they have to be pretty diligent, and
		#you can always ban their IP later. Of course, the whole cookie gambit
		#only works if you have multiple entries set to "no" in the config file.
		print 'Set-Cookie: SuperGuest=yes;\n';
		&Error("I cannot process your entry. Your entry apparently contained an attempt to flame the guestbook by typing in a huge string of letters with no spaces. Please be kinder in the future. Thank you.");
	    }
	}
    }
    
    print 'Set-Cookie: SuperGuest=yes;\n';
   
    #Our guestbook database is pipe-delimited, which means
    #if the user enters pipes in her entry, it will screw
    #the display of the entry up. Besides that, hackers will
    #try to use a pipe to get your system to do nasty things.
    #Therefore, I remove pipes from all the form fields.
    foreach (keys %in)
    {
	&StripMetas($in{$_});
    }
    
    open(OUTPUTREAD,"$GuestBook") || &Error("Can\'t open $GuestBook for reading in AddMe sub. Reason: $!");
    @OldGuestBook=<OUTPUTREAD>;
    close(OUTPUTREAD);
    open(OUTPUTWRITE,">$GuestBook") || &Error("Can\'t open $GuestBook for writing in AddMe sub. Reason: $!");
    
    #this flock command is the same as above. If your system doesn't support
    #it, comment it out.
    flock(OUTPUTWRITE,2) || &Error("Can\'t lock $GuestBook in AddMe sub. Reason: $!. If you continue to get this error, it may mean your server does not support the flock protocol. Comment out the flock line in the AddMe subroutine to avoid this error in the future.");
    $date = `date +"%D %T %Z"`;
    chomp($date);
    
    #since this will become the first entry in the guestbook (pushing all the others
    #down by one), set Rank value to 0 (the first item in the list)
    print OUTPUTWRITE "0\|";
    
    #since we've already printed the 0th item, start count with 1
    $CreationCount = 1;
    foreach (@fields)
    {
	#process until we have gone over all the items in the fields array
	if ($CreationCount < $FieldsCount)
	{
	    if ($fields[$CreationCount] =~ /date/gi)
	    {
		print OUTPUTWRITE "$date";
	    }
	    else
	    {
		print OUTPUTWRITE "$in{$fields[$CreationCount]}";
	    }
	    
	    #if the item is a comment, it's the last item in the line, and we
	    #don't want to end it with a pipe. Otherwise, we do.
	    unless ($fields[$CreationCount] =~ /comments/gi)
	    {
		print OUTPUTWRITE "\|";
	    }
	    $CreationCount++;
	}
    }
    
    #finally, we want the line to end with a newline character.
    print OUTPUTWRITE "\n";
    
    #set next item's rank to 1. That does two things:
    # FIRST, it makes sure we don't have to 0 ranks,
    # SECOND, it corrects any missing ranks created
    # by the edit routine.
    $NextRank = 1;
    foreach $oldie (@OldGuestBook)
    {
	($OldRank,$EthingElse) = split(/\|/,$oldie,2);
	$OldRank = $NextRank;
	$NextRank++;
	print OUTPUTWRITE "$OldRank\|$EthingElse";
    }
    close(OUTPUTWRITE);
    &ThankYou;
}
sub ThankYou
{
    &Header;
    &GetSiteHeader("ThankYou");
    print "<h1>Thank you</h1>\n";
    print "We have received your guestbook entry.<br>\n";
    print "Here's what you entered:<br>\n";
    for ($i = 0; $i < $FieldsCount; $i++)
    {
	if ($fields[$i] =~ /Rank|Action/gi)
	{
	    next;
	}
	else
	{
	    print "<b>$fields[$i]:</b> $in{$fields[$i]}<br>\n";
	}
	
    }
    print "<a href=$newform?View>View the guestbook</a><p>\n";
    &GetSiteFooter("ThankYou");
    &MailMe;
    exit;
}

sub MailMe
{
    if ($config{MailMe} =~ /yes/gi)
    {
	#Instead of opening a file with the open command,
	#we're piping data directly into the sendmail program.
	#As such, we must be very careful to prevent kooky hackers
	#from exploiting our system call. This is why the strip metas
	#subroutine is so important. 
	open (MAIL, "|$mailprog $config{MyEmail}") || &Error("Can't open $mailprog in MailMe sub. Reason: $!");
	print MAIL "Reply-to: $config{MyName} <$config{MyEmail}>\n";
	print MAIL "From: $config{MyName} <$config{MyEmail}>\n";
	print MAIL "Subject:Someone signed your guestbook\n\n";
	print MAIL "Someone signed your guestbook\n\n";
	for ($i = 0; $i < $FieldsCount; $i++)
	{
	    print MAIL "$fields[$i] : $in{$fields[$i]}\n";
	}
	print MAIL "\n If you want to ban this user, their IP is $ENV{REMOTE_HOST}\n";
	print MAIL "Date : $date\n";
	close (MAIL);
    }
}

	

sub StripMetas
{
    foreach (@_)
    {
	$_ =~ s/\||\r|\n//gi;
    }
}	

sub Sign
{
    $Hed{T} = $config{Title};
    &Header;
    &GetSiteHeader("Sign");
    if ($config{Title})
    {
	print "<h1>Sign $config{Title}</h1>\n";
    }
    else
    {
	print "<h1>Sign my guestbook</h1>\n";
    }
    print "<form action=$newform method=POST>\n";
    print "<input type=hidden name=action value=AddMe>\n";
    
    print "<table border=0><tr>\n";
    $DisplayCount = 1;
    foreach (@fields)
    {
	if ($DisplayCount < $FieldsCount)
	{
	    if ($fields[$DisplayCount] !~ /comments/gi)
	    {
		print "<tr><td><b>$fields[$DisplayCount]:</td><td><input type=text name=\"$fields[$DisplayCount]\"></td></tr>\n"; 
		$DisplayCount++;
	    }
	    else
	    {
		print "<tr><td colspan=2><center><b>$fields[$DisplayCount]:</b><br><textarea name=\"$fields[$DisplayCount]\" rows=10 cols=40></textarea></td></tr>\n";
		$DisplayCount++;
	    }
	}
    }
    print "<tr><td colspan=2><input type=submit value=\"Send my comments\"><input type=reset value=\"Quit and start over\"></td></tr>\n";
    print "</form>\n";
    &GetSiteFooter("Sign");
    exit;
}

sub GetSiteHeader
{
    $subber = join(//,@_);
    if ($config{Header})
    {
	open(SITEHED,"$config{Header}") || &Error("Can't open $config{Header} for $subber sub. Reason: $!");
	@SiteHed=<SITEHED>;
	close(SITEHED);
	foreach $SiteHed (@SiteHed)
	{
	    print "$SiteHed";
	}
    }
}

sub GetSiteFooter
{
    $subber = join(//,@_);
    if ($config{Footer})
    {
	open(SITEFOOT,"$config{Footer}") || &Error("Can't open $config{Footer} for $subber sub. Reason: $!");
	@SiteFoot=<SITEFOOT>;
	close(SITEFOOT);
	foreach $SiteFoot (@SiteFoot)
	{
	    print "$SiteFoot";
	}
    }
}